--- /dev/null
+#!/bin/sh
+# ensure that chmod diagnoses a certain type of invalid mode string
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chmod --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# Before coreutils-5.92, this would mistakenly succeed,
+# and act like `chmod 0 .'.
+chmod 0-followed-by-anything . 2> /dev/null && fail=1
+chmod 7-followed-by-anything . 2> /dev/null && fail=1
+chmod 8 . 2> /dev/null && fail=1
+
+(exit $fail); exit $fail